#include <bits/stdc++.h>

#define X			first
#define Y			second
#define endl		'\n'

using namespace std;

void readParam( int argc, char *argv[], int &test,
					int &minN, int &maxN,
					int &minM, int &maxM,
					int &minP, int &maxP,
					int &minK, int &maxK ) {
	test = atol( argv[1] );
	minN = atol( argv[2] );
	maxN = atol( argv[3] );
	minM = atol( argv[4] );
	maxM = atol( argv[5] );
	minP = atol( argv[6] );
	maxP = atol( argv[7] );
	minK = atol( argv[8] );
	maxK = atol( argv[9] );
}

void readParam( int &test,
				int &minN, int &maxN,
				int &minM, int &maxM,
				int &minP, int &maxP,
				int &minK, int &maxK ) {
	cin >> test;
	cin >> minN >> maxN;
	cin >> minM >> maxM;
	cin >> minP >> maxP;
	cin >> minK >> maxK;
}

void writeTest( int n, int m, vector< pair< int, int > > &g ) {
	cout << n << " " << m << endl;
	for( int i = 0; i < m; i ++ ) {
		cout << g[i].X << " " << g[i].Y << endl;
	}
}

int randNumber( int l, int r ) {
	int x = ( ( rand() << 16 ) + rand() ) % ( r - l + 1 ) + l;
	return x;
}

vector< int > randPermutation( int n ) {
	vector< int > v;
	for( int i = 1; i <= n; i ++ ) {
		v.push_back( i );
	}
	random_shuffle( v.begin(), v.end() );
	return v;
}

int cnt;

void add( int i, vector< int > &G ) {
	G.push_back( i );
	if( G.size() % 2 == 0 )
		cnt --;
	else
		cnt ++;
}

void add( int i, int j, vector< pair< int, int > > &g, vector< vector< int > > &G ) {
	pair< int, int > p = make_pair( i, j );
	g.push_back( p );
	add( i, G[j] );
	add( j, G[i] );
}

void add( int i, int j, vector< pair< int, int > > &g, vector< int > &P, vector< vector< int > > &G ) {
	add( i, j, g, G );
	P.push_back( i );
}

vector< pair< int, int > > randGraph( int n, int m, int p, int k ) {
	vector< int > v = randPermutation( n );
	vector< vector< int > > P( p ), G( n + 1 );
	for( int i = 0; i < p; i ++ ) {
		P[i].push_back( v[i] );
	}
	vector< pair< int, int > > g;
	for( int i = p; i < v.size(); i ++ ) {
		int j = randNumber( 0, p-1 );
		int k = randNumber( 0, P[j].size()-1 );
		add( v[i], P[j][k], g, P[j], G );
		m --;
	}
	for( int i = 1; i <= n; i ++ ) {
		if( G[i].size() )
			continue;
		add( i, i, g, G );
		m --;
	}
	while( cnt - k < 2 * m && m > 0 ) {
		int i = randNumber( 0, p-1 );
		int j = randNumber( 0, P[i].size()-1 );
		int k = randNumber( 0, P[i].size()-1 );
		add( P[i][j], P[i][k], g, G );
		m --;
	}
	if( cnt - k != 2 * m )
		k = cnt - 2 * m;
	vector< pair< int, int > > s;
	for( int i = 0; i < p; i ++ ) {
		vector< int > v;
		for( int jj = 0; jj < P[i].size(); jj ++ ) {
			int j = P[i][jj];
			if( G[j].size() % 2 )
				v.push_back( j );
		}
		random_shuffle( v.begin(), v.end() );
		for( int i = 0; i < v.size(); i += 2 ) {
			s.push_back( make_pair( v[i], v[i+1] ) );
		}
	}
	random_shuffle( s.begin(), s.end() );
	for( int i = 0; i < m; i ++ ) {
		add( s[i].X, s[i].Y, g, G );
	}
	if( cnt != k )
		exit( 1 );
	random_shuffle( g.begin(), g.end() );
	return g;
}

int main( int argc, char *argv[] ) {
	int test, minN, maxN, minM, maxM, minP, maxP, minK, maxK;

	readParam( argc, argv, test, minN, maxN, minM, maxM, minP, maxP, minK, maxK );
	//readParam( test, minN, maxN, minM, maxM, minP, maxP, minK, maxK );

	srand( test + minN + maxN + minM + maxM + minP + maxP + minK + maxK );

	int n = randNumber( minN, maxN );
	int m = randNumber( minM, maxM );
	int p = randNumber( minP, maxP );
	int k = randNumber( minK, maxK );

	p = min( p, n );

	if( m == 0 )
		m = n - 1;
	else
		m = max( m, n - p );

	k = min( k, n );
	if( k % 2 )
		k --;

	vector< pair< int, int > > g = randGraph( n, m, p, k );

	writeTest( n, m, g );
    return 0;
}
