#include <bits/stdc++.h>

#define X			first
#define Y			second
#define endl		'\n'

using namespace std;

void writeTest( int n, int m, vector< pair< int, int > > &g ) {
	cout << n << " " << m << endl;
	for( int i = 0; i < m; i ++ ) {
		cout << g[i].X << " " << g[i].Y << endl;
	}
}

int randNumber( int l, int r ) {
	int x = ( ( rand() << 16 ) + rand() ) % ( r - l + 1 ) + l;
	return x;
}

vector< int > randPermutation( int n ) {
	vector< int > v;
	for( int i = 1; i <= n; i ++ ) {
		v.push_back( i );
	}
	random_shuffle( v.begin(), v.end() );
	return v;
}

vector< pair< int, int > > randGraphFull( int n, int m ) {
	vector< pair< int, int > > g;
	for( int i = 1; i <= n; i ++ ) {
		for( int j = 1; j <= n; j ++ ) {
			g.push_back( make_pair( i, j ) );
		}
	}
	random_shuffle( g.begin(), g.end() );
	while( g.size() > m ) {
		g.pop_back();
	}
	return g;
}

vector< pair< int, int > > randGraph( int n, int m ) {
	if( m * 2 >= 1LL * n * n )
		return randGraphFull( n, m );
	vector< int > v = randPermutation( n );
	vector< pair< int, int > > g;
	set< pair< int, int > > u;
	for( int i = 1; i < v.size(); i ++ ) {
		int j = randNumber( 0, i-1 );
		pair< int, int > p = make_pair( v[i], v[j] );
		u.insert( p );
		g.push_back( p );
	}
	while( g.size() <= m ) {
		int a = randNumber( 1, n );
		int b = randNumber( 1, n );
		pair< int, int > p = make_pair( a, b );
		if( u.find( p ) != u.end() )
			continue;
		u.insert( p );
		g.push_back( p );
	}
	random_shuffle( g.begin(), g.end() );
	while( g.size() > m ) {
		g.pop_back();
	}
	return g;
}

int main( int argc, char *argv[] ) {
	int test = atol( argv[1] );
	int minN = atol( argv[2] );
	int maxN = atol( argv[3] );
	int maxM = atol( argv[4] );
	int minQ = atol( argv[5] );
	int maxQ = atol( argv[6] );

	srand( test + minN + maxN + maxM + minQ + maxQ );

	int n = randNumber( minN, maxN );
	int m = min( 1LL * n * n, 1LL * maxM );
	int q = randNumber( minQ, maxQ );

	vector< pair< int, int > > g = randGraph( n, m );

	for( int i = 0; i < q; i ++ ) {
		g.pop_back();
	}

	writeTest( n, m, g );
    return 0;
}
